#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

#define NUM_THREADS 10

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
int global;

void* add50000(void* param) {
	int i;
	pthread_mutex_lock(&mutex);
	for(i = 0; i < 50000; i++) {
		global += 1;
	}
	pthread_mutex_unlock(&mutex);
}

int main (int argc, char* argv[]) {
	global = 0;
	pthread_t thread[NUM_THREADS];
	int t, rc;
	for(t=0; t<NUM_THREADS; t++){
		rc = pthread_create(&thread[t], NULL, add50000, NULL);
		if (rc){
			printf("ERROR; return code from pthread_create() is %d\n", rc);
			exit(-1);
		}
	}
	for(t=0; t<NUM_THREADS; t++) {
		rc = pthread_join(thread[t], NULL);
		if (rc) {
			printf("ERROR; return code from pthread_join() is %d\n", rc);
			exit(-1);
		}
	}

	printf("global is %d\n", global);
}
